diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-acknowledgment.h ns-3.42/src/wifi/model/wifi-acknowledgment.h
--- ns-3.41/src/wifi/model/wifi-acknowledgment.h	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-acknowledgment.h	2024-05-29 15:29:47.208073900 -0700
@@ -29,6 +29,7 @@
 
 #include <map>
 #include <memory>
+#include <optional>
 
 namespace ns3
 {
@@ -101,8 +102,8 @@
      */
     virtual void Print(std::ostream& os) const = 0;
 
-    const Method method;     //!< acknowledgment method
-    Time acknowledgmentTime; //!< time required by the acknowledgment method
+    const Method method;                    //!< acknowledgment method
+    std::optional<Time> acknowledgmentTime; //!< time required by the acknowledgment method
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-assoc-manager.cc ns-3.42/src/wifi/model/wifi-assoc-manager.cc
--- ns-3.41/src/wifi/model/wifi-assoc-manager.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-assoc-manager.cc	2024-05-29 15:29:47.208073900 -0700
@@ -182,7 +182,7 @@
     for (auto ap = m_apList.begin(); ap != m_apList.end();)
     {
         if (!MatchScanParams(*ap) ||
-            (!m_allowedLinks.empty() && m_allowedLinks.count(ap->m_linkId) == 0))
+            (!m_allowedLinks.empty() && !m_allowedLinks.contains(ap->m_linkId)))
         {
             // remove AP info from list
             m_apListIt.erase(ap->m_bssid);
@@ -203,7 +203,7 @@
     NS_LOG_FUNCTION(this << apInfo);
 
     if (!CanBeInserted(apInfo) || !MatchScanParams(apInfo) ||
-        (!m_allowedLinks.empty() && m_allowedLinks.count(apInfo.m_linkId) == 0))
+        (!m_allowedLinks.empty() && !m_allowedLinks.contains(apInfo.m_linkId)))
     {
         return;
     }
@@ -314,7 +314,8 @@
         // mapping negotiation with the TID-To-Link Mapping Negotiation Support subfield of the
         // MLD Capabilities field of the Basic Multi-Link element it transmits to at least 1.
         // (Sec. 35.3.7.1.1 of 802.11be D3.1)
-        if (mldCapabilities->tidToLinkMappingSupport > 0 && negSupport.Get() == 0)
+        if (mldCapabilities->tidToLinkMappingSupport > 0 &&
+            negSupport.Get() == WifiTidToLinkMappingNegSupport::NOT_SUPPORTED)
         {
             NS_LOG_DEBUG("AP MLD supports TID-to-Link Mapping negotiation, while we don't");
             return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-default-ack-manager.cc ns-3.42/src/wifi/model/wifi-default-ack-manager.cc
--- ns-3.41/src/wifi/model/wifi-default-ack-manager.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-default-ack-manager.cc	2024-05-29 15:29:47.208073900 -0700
@@ -111,13 +111,10 @@
     NS_ABORT_MSG_IF(maxDistFromStartingSeq >= SEQNO_SPACE_HALF_SIZE,
                     "The given QoS data frame is too old");
 
-    const WifiTxParameters::PsduInfo* psduInfo = txParams.GetPsduInfo(receiver);
+    const auto* psduInfo = txParams.GetPsduInfo(receiver);
 
-    if (!psduInfo || psduInfo->seqNumbers.find(tid) == psduInfo->seqNumbers.end())
-    {
-        // there are no aggregated MPDUs (so far)
-        return maxDistFromStartingSeq;
-    }
+    NS_ASSERT_MSG(psduInfo && psduInfo->seqNumbers.contains(tid),
+                  "There must be at least an MPDU with tid " << +tid);
 
     for (const auto& seqNumber : psduInfo->seqNumbers.at(tid))
     {
@@ -193,7 +190,7 @@
                         "While searching for given MPDU ("
                             << *mpdu << "), found first another one (" << *item
                             << ") with higher sequence number");
-        if (auto linkIds = item->GetInFlightLinkIds(); linkIds.count(m_linkId) > 0)
+        if (auto linkIds = item->GetInFlightLinkIds(); linkIds.contains(m_linkId))
         {
             NS_LOG_DEBUG("Found MPDU inflight on the same link");
             return true;
@@ -280,7 +277,8 @@
 
     if (receiver.IsGroup())
     {
-        NS_ABORT_MSG_IF(txParams.GetSize(receiver) > 0, "Unicast frames only can be aggregated");
+        NS_ABORT_MSG_IF(!txParams.LastAddedIsFirstMpdu(receiver),
+                        "Unicast frames only can be aggregated");
         auto acknowledgment = std::make_unique<WifiNoAck>();
         if (hdr.IsQosData())
         {
@@ -327,7 +325,8 @@
 
     // we get here if a response is needed
     uint8_t tid = GetTid(mpdu->GetPacket(), hdr);
-    if (!hdr.IsBlockAckReq() && txParams.GetSize(receiver) == 0 && !ExistInflightOnSameLink(mpdu))
+    if (!hdr.IsBlockAckReq() && txParams.LastAddedIsFirstMpdu(receiver) &&
+        !ExistInflightOnSameLink(mpdu))
     {
         NS_LOG_DEBUG("Sending a single MPDU, no previous frame to ack: request Normal Ack");
         auto acknowledgment = std::make_unique<WifiNormalAck>();
@@ -338,7 +337,7 @@
     }
 
     // we get here if multiple MPDUs are being/have been sent
-    if (!hdr.IsBlockAckReq() && (txParams.GetSize(receiver) == 0 || m_useExplicitBar))
+    if (!hdr.IsBlockAckReq() && (txParams.LastAddedIsFirstMpdu(receiver) || m_useExplicitBar))
     {
         // in case of single MPDU, there are previous unacknowledged frames, thus
         // we cannot use Implicit Block Ack Request policy, otherwise we get a
@@ -385,8 +384,6 @@
     const WifiMacHeader& hdr = mpdu->GetHeader();
     Mac48Address receiver = hdr.GetAddr1();
 
-    const WifiTxParameters::PsduInfo* psduInfo = txParams.GetPsduInfo(receiver);
-
     NS_ABORT_MSG_IF(!hdr.IsQosData(),
                     "QoS data frames only can be aggregated when transmitting a "
                     "DL MU PPDU acknowledged via a sequence of BAR and BA frames");
@@ -402,15 +399,13 @@
         acknowledgment = static_cast<WifiDlMuBarBaSequence*>(txParams.m_acknowledgment.get());
     }
 
-    if (psduInfo)
+    if (!txParams.LastAddedIsFirstMpdu(receiver))
     {
         // an MPDU addressed to the same receiver has been already added
         NS_ASSERT(acknowledgment);
 
-        if ((acknowledgment->stationsSendBlockAckReqTo.find(receiver) !=
-             acknowledgment->stationsSendBlockAckReqTo.end()) ||
-            (acknowledgment->stationsReplyingWithBlockAck.find(receiver) !=
-             acknowledgment->stationsReplyingWithBlockAck.end()))
+        if (acknowledgment->stationsSendBlockAckReqTo.contains(receiver) ||
+            acknowledgment->stationsReplyingWithBlockAck.contains(receiver))
         {
             // the receiver either is already listed among the stations that will
             // receive a BlockAckReq frame or is the station that will immediately
@@ -510,8 +505,6 @@
     const WifiMacHeader& hdr = mpdu->GetHeader();
     Mac48Address receiver = hdr.GetAddr1();
 
-    const WifiTxParameters::PsduInfo* psduInfo = txParams.GetPsduInfo(receiver);
-
     NS_ASSERT(!txParams.m_acknowledgment ||
               txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_TF_MU_BAR);
 
@@ -521,7 +514,7 @@
         acknowledgment = static_cast<WifiDlMuTfMuBar*>(txParams.m_acknowledgment.get());
     }
 
-    if (!psduInfo)
+    if (txParams.LastAddedIsFirstMpdu(receiver))
     {
         // we get here if this is the first MPDU for this receiver.
         Ptr<ApWifiMac> apMac = DynamicCast<ApWifiMac>(m_mac);
@@ -600,8 +593,6 @@
     const WifiMacHeader& hdr = mpdu->GetHeader();
     Mac48Address receiver = hdr.GetAddr1();
 
-    const WifiTxParameters::PsduInfo* psduInfo = txParams.GetPsduInfo(receiver);
-
     NS_ASSERT(!txParams.m_acknowledgment ||
               txParams.m_acknowledgment->method == WifiAcknowledgment::DL_MU_AGGREGATE_TF);
 
@@ -611,7 +602,7 @@
         acknowledgment = static_cast<WifiDlMuAggregateTf*>(txParams.m_acknowledgment.get());
     }
 
-    if (!psduInfo)
+    if (txParams.LastAddedIsFirstMpdu(receiver))
     {
         // we get here if this is the first MPDU for this receiver.
         Ptr<ApWifiMac> apMac = DynamicCast<ApWifiMac>(m_mac);
@@ -709,8 +700,9 @@
             }
             NS_ABORT_MSG_IF(aid12 == 0 || aid12 > 2007, "Allocation of RA-RUs is not supported");
 
-            NS_ASSERT(apMac->GetStaList(m_linkId).find(aid12) != apMac->GetStaList(m_linkId).end());
-            Mac48Address staAddress = apMac->GetStaList(m_linkId).find(aid12)->second;
+            const auto it = apMac->GetStaList(m_linkId).find(aid12);
+            NS_ASSERT(it != apMac->GetStaList(m_linkId).end());
+            const auto staAddress = it->second;
 
             // find a TID for which a BA agreement exists with the given originator
             uint8_t tid = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-default-assoc-manager.cc ns-3.42/src/wifi/model/wifi-default-assoc-manager.cc
--- ns-3.41/src/wifi/model/wifi-default-assoc-manager.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-default-assoc-manager.cc	2024-05-29 15:29:47.208073900 -0700
@@ -240,7 +240,7 @@
     }
 
     if (std::none_of(m_channelSwitchInfo.begin(), m_channelSwitchInfo.end(), [](auto&& info) {
-            return info.timer.IsRunning();
+            return info.timer.IsPending();
         }))
     {
         // we are done
@@ -252,13 +252,13 @@
 WifiDefaultAssocManager::NotifyChannelSwitched(uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << +linkId);
-    if (m_channelSwitchInfo.size() > linkId && m_channelSwitchInfo[linkId].timer.IsRunning())
+    if (m_channelSwitchInfo.size() > linkId && m_channelSwitchInfo[linkId].timer.IsPending())
     {
         // we were waiting for this notification
         m_channelSwitchInfo[linkId].timer.Cancel();
 
         if (std::none_of(m_channelSwitchInfo.begin(), m_channelSwitchInfo.end(), [](auto&& info) {
-                return info.timer.IsRunning();
+                return info.timer.IsPending();
             }))
         {
             // we are done
@@ -282,7 +282,7 @@
     setupLinks.erase(it);
 
     if (std::none_of(m_channelSwitchInfo.begin(), m_channelSwitchInfo.end(), [](auto&& info) {
-            return info.timer.IsRunning();
+            return info.timer.IsPending();
         }))
     {
         // we are done
@@ -293,7 +293,7 @@
 bool
 WifiDefaultAssocManager::CanBeInserted(const StaWifiMac::ApInfo& apInfo) const
 {
-    return (m_waitBeaconEvent.IsRunning() || m_probeRequestEvent.IsRunning());
+    return (m_waitBeaconEvent.IsPending() || m_probeRequestEvent.IsPending());
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-default-protection-manager.cc ns-3.42/src/wifi/model/wifi-default-protection-manager.cc
--- ns-3.41/src/wifi/model/wifi-default-protection-manager.cc	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-default-protection-manager.cc	2024-05-29 15:29:47.212073800 -0700
@@ -51,6 +51,14 @@
                           "If enabled, always protect a DL/UL MU frame exchange with MU-RTS/CTS.",
                           BooleanValue(false),
                           MakeBooleanAccessor(&WifiDefaultProtectionManager::m_sendMuRts),
+                          MakeBooleanChecker())
+            .AddAttribute("SingleRtsPerTxop",
+                          "If enabled, a protection mechanism (RTS or MU-RTS) is normally used no "
+                          "more than once in a TXOP, regardless of the destination of the data "
+                          "frame (unless required for specific purposes, such as transmitting an "
+                          "Initial Control Frame to an EMLSR client).",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&WifiDefaultProtectionManager::m_singleRtsPerTxop),
                           MakeBooleanChecker());
     return tid;
 }
@@ -73,16 +81,10 @@
     // Call a separate method that handles MU-RTS/CTS protection in case of DL MU PPDU containing
     // more than one PSDU or in case the MPDU being added is addressed to an EMLSR client or in
     // case the protection method is already MU-RTS/CTS.
-    // A DL MU PPDU contains more than one PSDU if either the TX params' PSDU info map
-    // contains more than one entry or it contains one entry but the MPDU being added is
-    // addressed to a different receiver (hence generating a new entry if the MPDU is added)
     const auto& psduInfoMap = txParams.GetPsduInfoMap();
-    auto dlMuPpdu =
-        txParams.m_txVector.IsDlMu() &&
-        (psduInfoMap.size() > 1 ||
-         (psduInfoMap.size() == 1 && psduInfoMap.begin()->first != mpdu->GetHeader().GetAddr1()));
-    auto isEmlsrDestination =
-        GetWifiRemoteStationManager()->GetEmlsrEnabled(mpdu->GetHeader().GetAddr1());
+    auto dlMuPpdu = txParams.m_txVector.IsDlMu() && psduInfoMap.size() > 1;
+    const auto& hdr = mpdu->GetHeader();
+    auto isEmlsrDestination = GetWifiRemoteStationManager()->GetEmlsrEnabled(hdr.GetAddr1());
 
     if (dlMuPpdu || isEmlsrDestination ||
         (txParams.m_protection && txParams.m_protection->method == WifiProtection::MU_RTS_CTS))
@@ -102,7 +104,7 @@
     }
 
     // if this is a Trigger Frame, call a separate method
-    if (mpdu->GetHeader().IsTrigger())
+    if (hdr.IsTrigger())
     {
         return TryUlMuTransmission(mpdu, txParams);
     }
@@ -119,8 +121,7 @@
     NS_ASSERT(!txParams.m_protection || txParams.m_protection->method == WifiProtection::NONE);
 
     std::unique_ptr<WifiProtection> protection;
-    protection =
-        GetPsduProtection(mpdu->GetHeader(), txParams.GetSizeIfAddMpdu(mpdu), txParams.m_txVector);
+    protection = GetPsduProtection(hdr, txParams);
 
     // return the newly computed method if none was set or it is not NONE
     if (!txParams.m_protection || protection->method != WifiProtection::NONE)
@@ -157,9 +158,7 @@
     }
 
     std::unique_ptr<WifiProtection> protection;
-    protection = GetPsduProtection(msdu->GetHeader(),
-                                   txParams.GetSizeIfAggregateMsdu(msdu).second,
-                                   txParams.m_txVector);
+    protection = GetPsduProtection(msdu->GetHeader(), txParams);
 
     // the protection method may still be none
     if (protection->method == WifiProtection::NONE)
@@ -173,10 +172,9 @@
 
 std::unique_ptr<WifiProtection>
 WifiDefaultProtectionManager::GetPsduProtection(const WifiMacHeader& hdr,
-                                                uint32_t size,
-                                                const WifiTxVector& txVector) const
+                                                const WifiTxParameters& txParams) const
 {
-    NS_LOG_FUNCTION(this << hdr << size << txVector);
+    NS_LOG_FUNCTION(this << hdr << &txParams);
 
     // a non-initial fragment does not need to be protected, unless it is being retransmitted
     if (hdr.GetFragmentNumber() > 0 && !hdr.IsRetry())
@@ -184,8 +182,10 @@
         return std::make_unique<WifiNoProtection>();
     }
 
-    // no need to use protection if destination already received an RTS in this TXOP
-    if (m_mac->GetFrameExchangeManager(m_linkId)->GetProtectedStas().count(hdr.GetAddr1()) == 1)
+    // no need to use protection if destination already received an RTS in this TXOP or
+    // SingleRtsPerTxop is true and a protection mechanism has been already used in this TXOP
+    if (const auto& protectedStas = m_mac->GetFrameExchangeManager(m_linkId)->GetProtectedStas();
+        protectedStas.contains(hdr.GetAddr1()) || (m_singleRtsPerTxop && !protectedStas.empty()))
     {
         return std::make_unique<WifiNoProtection>();
     }
@@ -204,12 +204,12 @@
     }
 
     // check if RTS/CTS is needed
-    if (emlsrNeedRts || GetWifiRemoteStationManager()->NeedRts(hdr, size))
+    if (emlsrNeedRts || GetWifiRemoteStationManager()->NeedRts(hdr, txParams))
     {
         auto protection = std::make_unique<WifiRtsCtsProtection>();
         protection->rtsTxVector =
             GetWifiRemoteStationManager()->GetRtsTxVector(hdr.GetAddr1(),
-                                                          txVector.GetChannelWidth());
+                                                          txParams.m_txVector.GetChannelWidth());
         protection->ctsTxVector =
             GetWifiRemoteStationManager()->GetCtsTxVector(hdr.GetAddr1(),
                                                           protection->rtsTxVector.GetMode());
@@ -218,7 +218,7 @@
 
     // check if CTS-to-Self is needed
     if (GetWifiRemoteStationManager()->GetUseNonErpProtection() &&
-        GetWifiRemoteStationManager()->NeedCtsToSelf(txVector))
+        GetWifiRemoteStationManager()->NeedCtsToSelf(txParams.m_txVector))
     {
         auto protection = std::make_unique<WifiCtsToSelfProtection>();
         protection->ctsTxVector = GetWifiRemoteStationManager()->GetCtsToSelfTxVector();
@@ -236,19 +236,19 @@
 
     auto receiver = mpdu->GetHeader().GetAddr1();
     const auto& psduInfoMap = txParams.GetPsduInfoMap();
-    auto dlMuPpdu = txParams.m_txVector.IsDlMu() &&
-                    (psduInfoMap.size() > 1 ||
-                     (psduInfoMap.size() == 1 && psduInfoMap.begin()->first != receiver));
+    auto dlMuPpdu = txParams.m_txVector.IsDlMu() && psduInfoMap.size() > 1;
     auto isEmlsrDestination = GetWifiRemoteStationManager()->GetEmlsrEnabled(receiver);
     NS_ASSERT(
         dlMuPpdu || isEmlsrDestination ||
         (txParams.m_protection && txParams.m_protection->method == WifiProtection::MU_RTS_CTS));
 
-    auto isProtected =
-        m_mac->GetFrameExchangeManager(m_linkId)->GetProtectedStas().count(receiver) == 1;
+    const auto& protectedStas = m_mac->GetFrameExchangeManager(m_linkId)->GetProtectedStas();
+    const auto isProtected = protectedStas.contains(receiver);
     bool needMuRts =
         (txParams.m_protection && txParams.m_protection->method == WifiProtection::MU_RTS_CTS) ||
-        (dlMuPpdu && m_sendMuRts && !isProtected) || (isEmlsrDestination && !isProtected);
+        (dlMuPpdu && m_sendMuRts && !isProtected &&
+         (!m_singleRtsPerTxop || protectedStas.empty())) ||
+        (isEmlsrDestination && !isProtected);
 
     if (!needMuRts)
     {
@@ -266,7 +266,7 @@
         protection = static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
     }
 
-    if (txParams.GetPsduInfo(receiver) == nullptr)
+    if (txParams.LastAddedIsFirstMpdu(receiver))
     {
         // we get here if this is the first MPDU for this receiver.
         NS_ABORT_MSG_IF(m_mac->GetTypeOfStation() != AP, "HE APs only can send DL MU PPDUs");
@@ -281,6 +281,11 @@
             // txParams.m_protection points to an existing WifiMuRtsCtsProtection object.
             // We have to return a copy of this object including the needed changes
             protection = new WifiMuRtsCtsProtection(*protection);
+
+            // Add a User Info field for the new receiver
+            // The UL HE-MCS, UL FEC Coding Type, UL DCM, SS Allocation and UL Target RSSI fields
+            // in the User Info field are reserved (Sec. 9.3.1.22.5 of 802.11ax)
+            AddUserInfoToMuRts(protection->muRts, txWidth, receiver);
         }
         else
         {
@@ -298,7 +303,6 @@
             // Add a User Info field for each of the receivers already in the TX params
             for (const auto& [address, info] : txParams.GetPsduInfoMap())
             {
-                NS_ASSERT_MSG(address != receiver, "This must be the first MPDU for " << receiver);
                 AddUserInfoToMuRts(protection->muRts, txWidth, address);
             }
 
@@ -325,11 +329,6 @@
             GetWifiRemoteStationManager()->AdjustTxVectorForIcf(protection->muRtsTxVector);
         }
 
-        // Add a User Info field for the new receiver
-        // The UL HE-MCS, UL FEC Coding Type, UL DCM, SS Allocation and UL Target RSSI fields
-        // in the User Info field are reserved (Sec. 9.3.1.22.5 of 802.11ax)
-        AddUserInfoToMuRts(protection->muRts, txWidth, receiver);
-
         return std::unique_ptr<WifiMuRtsCtsProtection>(protection);
     }
 
@@ -364,6 +363,7 @@
     NS_ABORT_MSG_IF(m_mac->GetTypeOfStation() != AP, "HE APs only can send DL MU PPDUs");
     const auto& staList = StaticCast<ApWifiMac>(m_mac)->GetStaList(m_linkId);
 
+    const auto& protectedStas = m_mac->GetFrameExchangeManager(m_linkId)->GetProtectedStas();
     bool allProtected = true;
     bool isUnprotectedEmlsrDst = false;
 
@@ -375,8 +375,7 @@
         auto staIt = staList.find(userInfo.GetAid12());
         NS_ASSERT(staIt != staList.cend());
         AddUserInfoToMuRts(protection->muRts, txWidth, staIt->second);
-        bool isProtected =
-            m_mac->GetFrameExchangeManager(m_linkId)->GetProtectedStas().count(staIt->second) == 1;
+        const auto isProtected = protectedStas.contains(staIt->second);
         allProtected = allProtected && isProtected;
 
         isUnprotectedEmlsrDst =
@@ -384,7 +383,9 @@
             (!isProtected && GetWifiRemoteStationManager()->GetEmlsrEnabled(staIt->second));
     }
 
-    bool needMuRts = (m_sendMuRts && !allProtected) || isUnprotectedEmlsrDst;
+    bool needMuRts =
+        (m_sendMuRts && !allProtected && (!m_singleRtsPerTxop || protectedStas.empty())) ||
+        isUnprotectedEmlsrDst;
 
     if (!needMuRts)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-default-protection-manager.h ns-3.42/src/wifi/model/wifi-default-protection-manager.h
--- ns-3.41/src/wifi/model/wifi-default-protection-manager.h	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-default-protection-manager.h	2024-05-29 15:29:47.212073800 -0700
@@ -57,13 +57,12 @@
      * Select the protection method for a single PSDU.
      *
      * \param hdr the MAC header of the PSDU
-     * \param size the size in bytes of the PSDU
-     * \param txVector the TxVector used to transmit the PSDU
+     * \param txParams the TX parameters describing the PSDU
      * \return the selected protection method
      */
-    virtual std::unique_ptr<WifiProtection> GetPsduProtection(const WifiMacHeader& hdr,
-                                                              uint32_t size,
-                                                              const WifiTxVector& txVector) const;
+    virtual std::unique_ptr<WifiProtection> GetPsduProtection(
+        const WifiMacHeader& hdr,
+        const WifiTxParameters& txParams) const;
 
   private:
     /**
@@ -99,7 +98,8 @@
     virtual std::unique_ptr<WifiProtection> TryUlMuTransmission(Ptr<const WifiMpdu> mpdu,
                                                                 const WifiTxParameters& txParams);
 
-    bool m_sendMuRts; //!< true for sending an MU-RTS to protect DL MU PPDUs
+    bool m_sendMuRts;        //!< true for sending an MU-RTS to protect DL MU PPDUs
+    bool m_singleRtsPerTxop; //!< true for using protection only once in a TXOP
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-information-element.h ns-3.42/src/wifi/model/wifi-information-element.h
--- ns-3.41/src/wifi/model/wifi-information-element.h	2024-02-09 14:44:08.601795200 -0800
+++ ns-3.42/src/wifi/model/wifi-information-element.h	2024-05-29 15:29:47.212073800 -0700
@@ -235,6 +235,8 @@
 
 #define IE_EXT_NON_INHERITANCE ((WifiInformationElementId)56)
 
+#define IE_EXT_HE_6GHZ_CAPABILITIES ((WifiInformationElementId)59)
+
 #define IE_EXT_EHT_OPERATION ((WifiInformationElementId)106)
 #define IE_EXT_MULTI_LINK_ELEMENT ((WifiInformationElementId)107)
 #define IE_EXT_EHT_CAPABILITIES ((WifiInformationElementId)108)
